package ims.data;

import java.util.List;

public interface ISentence {

	public static final String ROOT="<root>";
	public static final String ROOT_STAG = ROOT+"/L+R";
	public static final String[] ROOT_STRING_ARR=new String[]{ROOT};
	public static final int ROOT_HEAD=-2;

	static final String[] UNDERSCORE_ARR={"_"};
	static final String   UNDERSCORE="_";
	static final String   BAR_REGEXP="\\|";

	
	public int getSentId();
	
	public int getLength(); //This is including the root token
	
	public String[] getForms();
	public String[] getTrainLemma();
	public String[] getTaggerTrainPOS();
	public String[] getParserTrainPOS();
	public String[] getFullTrainMorph();
	public String[][] getTrainMorph();
	public int[] getTrainHeads();
	public String[] getTrainLabels();
	
	public void setPredHeads(int[] heads);
	public void setPredLabels(String[] labels);
	public void setPredPOS(String[] pos);
	
	public int[] getGoldHeads();
	public String[] getGoldLabels();
	
	public int[] getPredHeads();
	public String[] getPredLabels();
	
	public List<String> getTabbedLineList();
	public String getTabbedToString();
	

	public String[] getStag();
	public int[] getStackHead();
	public String[] getStackLbl();

	public String[] getGoldPOS();
	
	public void reverseSentence();

	public void insertTokenOffsetsInHeadAndIDCols(int tokOffset);
	public void renormalizeTokenOffsetsInHeadAndIDCols(int tokOffset);

	public String getDocID();
	public ISentence getSubSentence(int b, int e, int tokOffset);

	public String[] getTaggerPredPOS();
	
	public ISentence createNBestSentence(List<Parse> parses);
	
}
