package ims.hotcoref.symbols;

import ims.util.Util;

public abstract class AbstractSymbolMapping<T> implements ISymbolMapping<T>{
	private static final long serialVersionUID = 154386098615065614L;
	
	public static final int UNK_IDX = 0;
	public static final int NONE_IDX = 1;
	public static final int INIT_IDX = 2;
	
	protected int next;
	protected boolean frozen;
	protected final String name;
	protected int _fBits=-1;

	public AbstractSymbolMapping(String name) {
		this.name=name;
		this.next=INIT_IDX;
		this.frozen=false;
	}

	@Override
	public int getItems() {
		return next;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public void freeze() {
		if(frozen)
			throw new UnsupportedOperationException("Cannot call freeze twice");
		_fBits=getBits();
		frozen=true;
	}

	@Override
	public int getBits() {
		if(frozen)
			return _fBits;
		else
			return Util.getBits(getItems());
	}
}
