package ims.io;

import ims.data.ISentence;
import ims.util.AbstractSingleItemBufferedIterator;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

public class StreamIteratorReader extends AbstractSingleItemBufferedIterator<ISentence> {

	public final Format f;
	private final BufferedReader reader;
	private final Method makeSentenceMethod;
	
	private int sid=0;
	
	public StreamIteratorReader(InputStream is,Format format) throws IOException{
		reader=new BufferedReader(new InputStreamReader(is,"utf8"));
		f=format;
		Method m=null;
		try {
			m=format.sentenceClass.getMethod("lines2Sentence",List.class,Integer.class);
		} catch (NoSuchMethodException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.makeSentenceMethod=m;
		super.initSetNext(init());
	}
	
	@Override
	protected ISentence readNext() throws IOException {
		List<String> l=new ArrayList<String>();
		String line;
		while((line=reader.readLine())!=null){
			if(line.matches(AbstractReader.EMPTY_LINE_REGEXP))
				break;
			l.add(line);
		}
		if(l.isEmpty())
			return null;
		ISentence s=null;
		try {
			s=(ISentence) makeSentenceMethod.invoke(null, l,sid++);
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return s;
	}

	@Override
	protected ISentence init() throws IOException {
		return readNext();
	}

}
