package ims.io;

import ims.data.ISentence;
import ims.trans.Options;
import ims.util.NonProjInfo;

import java.io.IOException;

public class TakeNonProjSen {

	public static void main(String[] args) throws IOException{
		Options options=new Options(args);
		SentenceReader<?> reader=ProjDiscardingReader.createReader((ReaderWriterFactory.getReader(options.train,Options.format.sentenceClass)));
		TabbedWriter writer=ReaderWriterFactory.getWriter(options.out);
		for(ISentence s:reader){
			int[] head=s.getGoldHeads();
			NonProjInfo proj=new NonProjInfo(head); //Now we're effectively checking projectivity twice, once in the reader, and once here. But I'm lazy, and for now I can live with it.
			int left=0;
			int right=0;
			for(int dep=1;dep<head.length;++dep){
				if(proj.isNonProjectiveEdge[dep]){
					if(head[dep]<dep) //dep on right
						right++;
					else
						left++;
				}
			}
			if(options.keepNonProjArcCount>0 && proj.totalNonProjArcs!=options.keepNonProjArcCount)
				continue;
			if(options.left>0 && left!=options.left)
				continue;
			if(options.right>0 && right!=options.right)
				continue;
			
			writer.write(s);
		}
		writer.close();
	}
	
}
