package ims.oracle;

import java.util.Arrays;

import ims.data.Buffer;
import ims.data.Stack;
import ims.oracle.Configuration.TR;

public class MinimalConfigurationWTRSig extends MinimalConfiguration{

	String trSig;
	
	public MinimalConfigurationWTRSig(int[] heads) {
		super(heads);
		this.trSig="0";
	}
	
	private MinimalConfigurationWTRSig(Stack s, Buffer b, int[] rD,	int totalTransitions, int[] pH, String trSig) {
		super(s,b,rD,totalTransitions,pH);
		this.trSig=trSig;
	}

	@Override
	public void doLA(){
		trSig+=TR.LA.k;
		super.doLA();
	}
	@Override
	public void doRA(){
		trSig+=TR.RAS.k;
		super.doRA();
	}
	@Override
	public void doShift(){
		trSig+=TR.SH.k;
		super.doShift();
	}
	@Override
	public void doSwap(){
		trSig+=TR.SW.k;
		super.doSwap();
	}
	@Override
	public String getTransitionSeqSignature(){
		return trSig;
	}
	@Override	
	public MinimalConfigurationWTRSig deepCopy(){
		Stack s=stack.copy();
		Buffer b=buffer.copy();
		int[] rD=Arrays.copyOf(remainingDeps, remainingDeps.length);
		int[] pH=Arrays.copyOf(predHeads, predHeads.length);
		return new MinimalConfigurationWTRSig(s,b,rD,totalTransitions,pH,trSig);
	}

}
