package ims.oracle;

import java.io.IOException;
import java.util.List;

import ims.data.ISentence;
import ims.io.NonProjDiscardingReader;
import ims.io.ReaderWriterFactory;
import ims.io.SentenceReader;
import ims.trans.Options;
import ims.util.Util;

public class PrintTransitions {

	public static void main(String[] args) throws IOException{
		Options options=new Options(args);
		PlotOracleLattice.VERBOSE_ERRORS=false;
//		SentenceReader<?> reader=ReaderWriterFactory.getReader(options.train, options.format.sentenceClass);
		SentenceReader<?> reader=ReaderWriterFactory.getTrainReader(options);
		if(options.discardNonProj)
			reader=NonProjDiscardingReader.createReader(reader);
		IOracle oracle=OracleFactory.getVanillaOracle(options.oracle, options.transitionSystem);
		int i=0;
		for(ISentence s:reader){
			if(i>=options.count)
				break;
			int[] head=s.getGoldHeads();
			String[] lbl=s.getGoldLabels();
			List<String> seq=oracle.getCanonicalSequence(head, lbl, options.labeled);
			System.out.println(Util.joinStrings(seq, ","));
			++i;
		}
	}
	
}
