package ims.tag;

import java.util.Arrays;

public class TagContext implements ITagContext {
	
	private int[] tags;
	
	public TagContext(int length){
		this.tags=new int[length];
		Arrays.fill(tags, UNK);
	}
	
	public TagContext(int[] tags) {
		this.tags=new int[tags.length];
		System.arraycopy(tags, 0, this.tags, 0, tags.length);
	}

	public int getTag(int idx,int offset){
		return getTag(idx+offset);
	}
	
	public int getTag(int idx){
		if(idx<1 || idx>=tags.length)
			return NONE;
		else
			return tags[idx];
	}
	
	public void setTag(int idx,int tag){
		if(idx<tags.length && idx>0)
			tags[idx]=tag;
	}

}
