package ims.tag;

import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.util.zip.ZipOutputStream;

import ims.hotcoref.symbols.TagSymbolTable;
import ims.perceptron.Long2IntInterface;
import ims.util.ZipUtil;

public class TagModel implements Serializable{

	private static final long serialVersionUID = 98948717763079264L;

	public static final String ZIP_ENTRY="_model";
	public static final String INFO_ENTRY="info";
	
	float[] parameters;
	Long2IntInterface l2i;
	TagSymbolTable symTab;
	TagInstanceCreator instanceCreator;
	IDecoder decoder;
	
	public TagModel(float[] parameters, Long2IntInterface l2i, TagSymbolTable symTab, TagInstanceCreator instanceCreator, IDecoder decoder) {
		this.parameters = parameters;
		this.l2i = l2i;
		this.symTab = symTab;
		this.instanceCreator=instanceCreator;
		this.decoder=decoder;
	}
	
	public void saveModel(File file,String... info) throws IOException {
		ZipOutputStream zos=ZipUtil.openZOS(file);
		ZipUtil.writeObjectAsZipEntry(zos, ZIP_ENTRY, this);
		ZipUtil.writeStringTXT(zos, INFO_ENTRY, info);
		zos.close();
	}
	
	public static TagModel loadModel(File file) throws IOException, ClassNotFoundException {
		TagModel model=ZipUtil.loadObjectFromEntry(ZIP_ENTRY, file, TagModel.class);
		return model;
	}
	
//	public FeatureScorer getFeatureScorer(){
//		return new FeatureScorer(fs, l2i, parameters, symTab);
//	}
	
	public IDecoder getDecoder(){
		return decoder;
	}
	
}
