package ims.tag.features;

import ims.hotcoref.symbols.AbstractSymbolMapping;

public class Potentials {

	private final double[][] potentials;
	
	public Potentials(double[][] potentials){
		this.potentials=potentials;
		for(int i=0;i<potentials.length;++i)
			for(int p=0;p<AbstractSymbolMapping.INIT_IDX;++p)
				this.potentials[i][p]=Double.NEGATIVE_INFINITY;
	}
	
	public double getPotential(int idx,int tag){
		return potentials[idx][tag];
	}
	
	public int bestPotential(int idx){
		int best=AbstractSymbolMapping.INIT_IDX;
		double bestScore=getPotential(idx,best);
		for(int i=best+1;i<potentials[idx].length;++i){
			if(bestScore<getPotential(idx,i)){
				bestScore=getPotential(idx,i);
				best=i;
			}
		}
		return best;
	}
	
	public double[] getPotentialArray(int idx){
		return potentials[idx];
	}
	
	public int getLength(){
		return potentials.length;
	}
	
}
