package ims.trans;

public interface IBuffer {

	//We make these objects immutable, so we don't need to copy them
//	public IBuffer copy();
	
	//Return a new buffer where s has been pushed back on the buffer
	public IBuffer pushBack(State s);
	public int size();
	//get the n'th item in the buffer (0 is front), but return -1 if there is no such item
	public int get(int n);
	//Return a new buffer without the front item
	public IBuffer advance();
	//See if there is something pushed back (otherwise null)
	public State peekPushedBack();
	//For features
	public boolean hasSwappedItems();
	//Equality test
	public boolean equals(IBuffer b);
	public boolean equals(SimpleBuffer other);
	public boolean equals(PushbackBuffer other);
	public IBuffer deepCopy();
	public int getNoPushedBack();
	
}
