package ims.trans;

import ims.util.LeveledRollbackRNG;

public class PRNGDropOut implements IDropOut {
	
	protected final double acceptTH;
	protected final LeveledRollbackRNG rng;
	
	public PRNGDropOut(double acceptTH,long seed){
		this.acceptTH=acceptTH;
		this.rng=new LeveledRollbackRNG(seed);
	}

	@Override
	public boolean acceptNext() {
		double d=rng.nextDouble();
		return d<acceptTH;
	}

	@Override
	public void rollbackSentence() {
		rng.rollbackSentence();
	}

	@Override
	public void rollbackFeatures() {
		rng.rollbackFeatures();
	}

	@Override
	public void advanceState() {
		rng.advanceState();
	}

	@Override
	public void advanceSentence() {
		rng.advanceSentence();
	}

	@Override
	public void revertState() {
		rng.revertState();
	}

}
