package ims.trans.features;

import ims.data.Instance;
import ims.hotcoref.symbols.AbstractSymbolMapping;
import ims.hotcoref.symbols.SymbolTable;
import ims.trans.FeatureExtractor;
import ims.trans.State;

public class FS_DumbStandard extends FeatureExtractor{
	private static final long serialVersionUID = -6434318953730936842L;

	public FS_DumbStandard(SymbolTable symTab) {
		super(symTab);
	}	
	public int extractFeatures(State s,long[] sink,Instance inst){
		
		//Stack
		int s0=s.s0;
		int s1,s2;
		s1=s2=-1;
		int s0f,s0t,s1f,s1t,s2t;
		int s0lp;
		s0f=s0t=s1f=s1t=s2t=s0lp=NONE;
		
		
		if(s0>=0){  //s0 a token?
			s0f=inst.form[s0];
			s0t=inst.tag[s0];
			if(s.tail!=null){ //s0 has other item on the stack below?
				s1=s.tail.s0;
			}
			if(s.s0L>0){ 
				s0lp=inst.tag[s.s0L];
			}
		}
		if(s1>=0){ //s1 is a token
			s1f=inst.form[s1];
			s1t=inst.tag[s1];
			if(s.tail.tail!=null) //s1 has other item on the stack below{
				s2=s.tail.tail.s0;
		}
		if(s2>=0){
			s2t=inst.form[s2];
		}
		
		//Buffer
		int b0=s.buf.get(0);
		int b0t=b0!=-1?inst.tag[b0]:AbstractSymbolMapping.NONE_IDX;
		
		
		int t=1; //Template index
		int i=0; //Where to put in sink

		sink[i]=t; sink[i]<<=bF; sink[i]|=s0f;  ++t; ++i;
		sink[i]=t; sink[i]<<=bT; sink[i]|=s0t;  ++t; ++i;
		sink[i]=t; sink[i]<<=bF; sink[i]|=s1f;  ++t; ++i;
		sink[i]=t; sink[i]<<=bT; sink[i]|=s1t;  ++t; ++i;
		sink[i]=t; sink[i]<<=bT; sink[i]|=s2t;  ++t; ++i;
		sink[i]=t; sink[i]<<=bT; sink[i]|=b0t;  ++t; ++i;
		sink[i]=t; sink[i]<<=bT; sink[i]|=s0lp; ++t; ++i;
		return i;
	}
	

}
